//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.RecoverableErrorProvider
{
    
    
    /// <summary>
    /// A class that exposes the IRecoverableErrorProvider interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class RecoverableErrorProviderProvider : IFeatureProvider
    {
        
        private IRecoverableErrorProvider _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(RecoverableErrorProviderProvider).Assembly, "RecoverableErrorProvider.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public RecoverableErrorProviderProvider(IRecoverableErrorProvider implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        private System.Exception ConvertRaiseRecoverableErrorExceptions(System.Exception exception)
        {
            try
            {
                throw exception;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "durationUntilError"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/RecoverableErrorProvider/v1/Command/RaiseRecoverableError/P" +
                            "arameter/DurationUntilError", ex.Message);
                }
                if ((ex.ParamName == "automaticExecutionTimeout"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/RecoverableErrorProvider/v1/Command/RaiseRecoverableError/P" +
                            "arameter/AutomaticExecutionTimeout", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterObservableCommand<RaiseRecoverableErrorRequestDto, string, RaiseRecoverableErrorResponseDto>("RaiseRecoverableError", RaiseRecoverableError, ConvertRaiseRecoverableErrorResponse, ConvertRaiseRecoverableErrorExceptions);
        }
        
        private RaiseRecoverableErrorResponseDto ConvertRaiseRecoverableErrorResponse(string result)
        {
            return new RaiseRecoverableErrorResponseDto(result, _server);
        }
        
        /// <summary>
        /// Executes the Raise Recoverable Error command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual Tecan.Sila2.IObservableCommand<string> RaiseRecoverableError(RaiseRecoverableErrorRequestDto request)
        {
            request.Validate();
            return _implementation.RaiseRecoverableError(request.DurationUntilError.TryExtract(_server, "org.silastandard/test/RecoverableErrorProvider/v1/Command/RaiseRecoverableError/P" +
                        "arameter/DurationUntilError"), request.AutomaticExecutionTimeout.TryExtract(_server, "org.silastandard/test/RecoverableErrorProvider/v1/Command/RaiseRecoverableError/P" +
                        "arameter/AutomaticExecutionTimeout"));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/RecoverableErrorProvider/v1/Command/RaiseRecoverableError"))
            {
                return typeof(IRecoverableErrorProvider).GetMethod("RaiseRecoverableError");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

